/* grctoi.f -- translated by f2c (version 20090411).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "pgplot.h"

/* *GRCTOI -- convert character string to integer */
/* + */
integer grctoi_(char *s, integer *i__, ftnlen s_len)
{
    /* Initialized data */

    static char digits[1*10] = "0" "1" "2" "3" "4" "5" "6" "7" "8" "9";

    /* System generated locals */
    integer ret_val;

    /* Local variables */
    static integer k, x, sign;


/* GRCTOI: attempt to read an integer from a character string, and return */
/* the result. No attempt is made to avoid integer overflow. A valid */
/* integer is any sequence of decimal digits. */

/* Returns: */
/*  GRCTOI           : the value of the integer; if the first character */
/*                    read is not a decimal digit, the value returned */
/*                    is zero. */
/* Arguments: */
/*  S      (input)  : character string to be parsed. */
/*  I      (in/out) : on input, I is the index of the first character */
/*                    in S to be examined; on output, either it points */
/*                    to the next character after a valid integer, or */
/*                    it is equal to LEN(S)+1. */

/* -- */
/*  1985 Oct  8 - New routine, based on CTOI (T. J. Pearson). */
/*  1997 Jun  3 - allow leading + or - sign (TJP). */
/* ----------------------------------------------------------------------- */

    x = 0;
    sign = 1;
    if (*i__ > s_len) {
	goto L30;
    }
    if (*(unsigned char *)&s[*i__ - 1] == '+') {
	++(*i__);
    } else if (*(unsigned char *)&s[*i__ - 1] == '-') {
	++(*i__);
	sign = -1;
    }
L10:
    if (*i__ > s_len) {
	goto L30;
    }
    for (k = 0; k <= 9; ++k) {
	if (*(unsigned char *)&s[*i__ - 1] == *(unsigned char *)&digits[k]) {
	    x = x * 10 + k;
	    ++(*i__);
	    goto L10;
	}
/* L20: */
    }
L30:
    ret_val = x * sign;
    return ret_val;
} /* grctoi_ */

