#include "pgplot.h"

void GRCLOS() {
	float RBUF[6];
	int NBUF, LCHR;
	char CHR;
	int IFUNC;
	int COLOR;

/*
 * Check a plot is open.
 */
	if (grcm00_.grcide < 1) return;

/*
 * Reset color to default (1). This is useful
 * for VT240 terminals, which use the color tables for text.
 */
	COLOR = 1;
	GRSCI(&COLOR);

/*
 * Flush buffer.
 */
	GRTERM();

/*
 * End picture.
 */
	GREPIC();

/*
 * This plot identifier is no longer in use.
 * Set state to "workstation closed".
 */
	grcm00_.grstat[grcm00_.grcide - 1] = 0;
	grcm00_.grcide = 0;

/*
 * Close workstation.
 */
	IFUNC = 10;
	GREXEC(&grcm00_.grgtyp, &IFUNC, RBUF, &NBUF, &CHR, &LCHR, 1);
}

